LPARAMETERS lcChanel,lcNick,lcSummary,lcDType,lcText

* lcChanel  - Chanel name with char # (#foxpro, #vfp)
* lcNick    - Nick Name
* lcSummary - Summary text
* lcDType   - F (File), C (clipboard), S (selected text on top window), [empty]
* lcText    - for lcDType="F" is file name, cbopaste read the file
* lcText    - for lcDType="C" is empty, but text for cbopaste get from variable _cliptext
* lcText    - for lcDType="S" is empty, but text for cbopaste get from top window and selected text
* lcText    - for lcDType=" " is  text for cbopaste


IF EMPTY(lcChanel) OR EMPTY(lcNick)
   ?"No parameters?"
   RETURN
ENDIF

LOCAL lcPath,xxa,lcHeader,lcParam,lcObject,lcServer,llNew,llLoadB,;
      liRet,liPT,lcST,liLG,lcData,lcHTML,liVers,lcErr,llErr,liWH
LOCAL ARRAY laEnv(25)
lcPath=SYS(16)
lcPath=IIF(RAT("\",m.lcPath)>0,LEFT(m.lcPath,RAT("\",m.lcPath)),m.lcPath)

IF m.lcDTYPE=="F" && File name
   IF !FILE(m.lcText)
      ?"File doesn't exist"
      RETURN
   ENDIF
   lcErr=ON("ERROR")
   ON ERROR llErr=.T.
   lcData=FILETOSTR(m.lcText)
   IF EMPTY(m.lcErr)
      ON ERROR
   ELSE
      ON ERROR &lcErr.
   ENDIF
   IF llErr
      ?"Cannot open file"
   ENDIF
ENDIF

IF ALLT(m.lcDTYPE)=="" && text
   lcData=m.lcText
ENDIF

IF m.lcDTYPE=="C" && _Clipboard
   lcData=_ClipText
ENDIF

IF EMPTY(lcSummary)
   lcSummary=""
ENDIF


IF m.lcDTYPE=="S" && Selected text
   IF ATC("foxtools.fll",SET("Library"))=0
      IF !FILE(HOME(0)+"foxtools.fll")
         ?"Cann't locate foxtools.fll"
         RETURN
      ENDIF
      SET LIBRARY TO (HOME(0)+"foxtools.fll")
      llNew=.T.
   ENDIF
   liWh=_WOnTop()
*   _EdCopy(liWh)
*   lcData=_cliptext

   lcEnv=REPLICATE(CHR(0),380)
   _EdGetEnv(liWh, @laEnv)

*261
*4
*2*14
*4*2 start+end
*4+2
*2
*64
*2*3
   lcData=_EDGETSTR(m.liWh,laEnv(17),laEnv(18))

   IF m.llNew
      RELEASE LIBRARY (HOME(0)+"foxtools.fll")
   ENDIF
ENDIF


*!*    lcChanel="#vfp"
*!*    lcNick="AutoPaste"
*!*    lcSummary="test of autopaste from vfp"
*!*    lcData=FILETOSTR(lcPath+"cbopaste.prg")

liVers=VAL(STRTRAN(SUBS(VERSION(),LEN("Visual FoxPro ")+1,2),"0",""))


*!*	    <form method='post' action='paste' enctype='application/x-www-from-urlencoded' name="pasteForm">
*!*	     <font face="courier new" size="-1"><br><br>
*!*	     1. channel: <select name='channel'><option value="">(none)</option> <option value="#foxpro">#foxpro</option> <option value="#vfp" selected>#vfp</option> <option value="#visualfoxpro">#visualfoxpro</option></select>&nbsp; &nbsp;
*!*	     2. your nick: <input type='text' name='nick' size='25' maxlength='25'><br><br>
*!*	     3. summary: <input type='text' name='summary' size='80' maxlength='160'><br><br>
*!*	     4. paste: <textarea name='paste' rows=25 cols=75 style='width:100%'></textarea><br><br>
*!*	     5. <input type='submit' name='Paste it' value='Paste it'><input type='reset' name='Clear form' value='Clear form'>
*!*	     </font>


IF ATC("botthrd.fll",SET("Library"))=0
   IF !FILE(m.lcPath+"botthrd.fll")
      ?"Cann't locate botthrd.fll"
      RETURN
   ENDIF
   SET LIBRARY TO  (m.lcPath+"botthrd.fll") ADDITIVE
   llLoadB=.T.
ENDIF
* Conver to UTF8 and safecharacters
lcChanel=ToSafeCharacters(STRCONV(m.lcChanel,9))
lcNick=ToSafeCharacters(STRCONV(m.lcNick,9))
lcSummary=ToSafeCharacters(STRCONV(m.lcSummary,9))
lcData=ToSafeCharacters(STRCONV(m.lcData,9))


?"Create thread"
lcHeader=[Content-Type: application/x-www-form-urlencoded; charset="utf-8"]+CHR(13)+CHR(10)
lcParam="channel="+lcChanel+"&nick="+lcNick+"&summary="+lcSummary+"&paste="+lcData+"&Paste%20it=Paste%20it"
lcObject="paste"
lcServer="paste.foxshare.net"
xxa=bot_readurlbypost(lcServer,lcObject,lcParam,lcHeader,32,8888)

?"Wait for... data sending"
DO WHILE .T.
   liRet=bot_getthrstate(xxa)
   IF liRet#0
      EXIT
   ENDIF

   liPT=bot_getthrdata(xxa)
   lcST=IIF(liVers>=7,SYS(2600,liPT,12),bot_SYS2600(liPT,12)) && Read structure
   liLG=C4ToI(SUBST(lcST,9,4)) && Lenght of reading string

   ?"State",liRet,liLG
   =INKEY(1)
ENDDO
?liRet,"","Data send..."
IF liRet=1
   liPT=bot_getthrdata(xxa)
   lcST=IIF(liVers>=7,SYS(2600,liPT,12),bot_SYS2600(liPT,12)) && Read structure

   liPT=C4ToI(LEFT(lcST,4)) && Pointer to string
   liLG=C4ToI(SUBST(lcST,9,4)) && Lenght of reading string

   lcHTML=IIF(liVers>=7,SYS(2600,liPT,liLG),bot_SYS2600(liPT,liLG))
ENDIF
?"Relase sources"
=bot_freethrdata(xxa)
?lcHTML

IF llLoadB
   RELEASE LIBRARY (m.lcPath+"botthrd.fll")
ENDIF


********************************
PROCEDURE C4ToI(lcInt)
RETURN ASC(LEFT(m.lcInt,1))+;
       ASC(SUBS(m.lcInt,2,1))*256+;
       ASC(SUBS(m.lcInt,3,1))*65536+;
       ASC(RIGHT(m.lcInt,1))*256*65536
ENDPROC

********************************
PROCEDURE C4ToL(lcLong)
LOCAL liVal
liVal=ASC(LEFT(lcLong,1))+;
                  ASC(SUBS(lcLong,2,1))*256+;
                  ASC(SUBS(lcLong,3,1))*65536+;
                  ASC(RIGHT(lcLong,1))*16777216

RETURN IIF(liVal<=0x7FFFFFFF,liVal,liVal-(0xFFFFFFFF+1))

*********************************************************************************************
PROCEDURE ToSafeCharacters(lcText)
LOCAL lcChar,lii
lcText=STRTRAN(m.lcText,"%","%"+RIGHT(TRANSFORM(37,"@0"),2))
FOR lii=0 TO 255
    lcChar=CHR(m.lii)
    IF !ISDIGIT(m.lcChar) AND !ISALPHA(m.lcChar) AND lii#37 AND AT(m.lcChar,m.lcText)>0
       lcText=STRTRAN(m.lcText,m.lcChar,"%"+RIGHT(TRANSFORM(ASC(m.lcChar),"@0"),2))
    ENDIF
NEXT
RETURN m.lcText


*!*	50 4F 53 54 20 2F 70 61 73 74 65 20 48 54 54 50  POST /paste HTTP
*!*	2F 31 2E 31 0D 0A 55 73 65 72 2D 41 67 65 6E 74  /1.1..User-Agent
*!*	3A 20 4D 6F 7A 69 6C 6C 61 2F 34 2E 30 20 28 63  : Mozilla/4.0 (c
*!*	6F 6D 70 61 74 69 62 6C 65 3B 20 4D 53 49 45 20  ompatible; MSIE 
*!*	36 2E 30 3B 20 57 69 6E 64 6F 77 73 20 4E 54 20  6.0; Windows NT 
*!*	35 2E 31 3B 20 65 6E 29 20 4F 70 65 72 61 20 38  5.1; en) Opera 8
*!*	2E 30 0D 0A 48 6F 73 74 3A 20 70 61 73 74 65 2E  .0..Host: paste.
*!*	66 6F 78 73 68 61 72 65 2E 6E 65 74 3A 38 38 38  foxshare.net:888
*!*	38 0D 0A 41 63 63 65 70 74 3A 20 74 65 78 74 2F  8..Accept: text/
*!*	68 74 6D 6C 2C 20 61 70 70 6C 69 63 61 74 69 6F  html, applicatio
*!*	6E 2F 78 6D 6C 3B 71 3D 30 2E 39 2C 20 61 70 70  n/xml;q=0.9, app
*!*	6C 69 63 61 74 69 6F 6E 2F 78 68 74 6D 6C 2B 78  lication/xhtml+x
*!*	6D 6C 2C 20 69 6D 61 67 65 2F 70 6E 67 2C 20 69  ml, image/png, i
*!*	6D 61 67 65 2F 6A 70 65 67 2C 20 69 6D 61 67 65  mage/jpeg, image
*!*	2F 67 69 66 2C 20 69 6D 61 67 65 2F 78 2D 78 62  /gif, image/x-xb
*!*	69 74 6D 61 70 2C 20 2A 2F 2A 3B 71 3D 30 2E 31  itmap, */*;q=0.1
*!*	0D 0A 41 63 63 65 70 74 2D 4C 61 6E 67 75 61 67  ..Accept-Languag
*!*	65 3A 20 63 73 3B 71 3D 31 2E 30 2C 65 6E 3B 71  e: cs;q=1.0,en;q
*!*	3D 30 2E 39 0D 0A 41 63 63 65 70 74 2D 43 68 61  =0.9..Accept-Cha
*!*	72 73 65 74 3A 20 77 69 6E 64 6F 77 73 2D 31 32  rset: windows-12
*!*	35 30 2C 20 75 74 66 2D 38 2C 20 75 74 66 2D 31  50, utf-8, utf-1
*!*	36 2C 20 69 73 6F 2D 38 38 35 39 2D 31 3B 71 3D  6, iso-8859-1;q=
*!*	30 2E 36 2C 20 2A 3B 71 3D 30 2E 31 0D 0A 41 63  0.6, *;q=0.1..Ac
*!*	63 65 70 74 2D 45 6E 63 6F 64 69 6E 67 3A 20 64  cept-Encoding: d
*!*	65 66 6C 61 74 65 2C 20 67 7A 69 70 2C 20 78 2D  eflate, gzip, x-
*!*	67 7A 69 70 2C 20 69 64 65 6E 74 69 74 79 2C 20  gzip, identity, 
*!*	2A 3B 71 3D 30 0D 0A 43 6F 6E 6E 65 63 74 69 6F  *;q=0..Connectio
*!*	6E 3A 20 4B 65 65 70 2D 41 6C 69 76 65 2C 20 54  n: Keep-Alive, T
*!*	45 0D 0A 54 45 3A 20 64 65 66 6C 61 74 65 2C 20  E..TE: deflate, 
*!*	67 7A 69 70 2C 20 63 68 75 6E 6B 65 64 2C 20 69  gzip, chunked, i
*!*	64 65 6E 74 69 74 79 2C 20 74 72 61 69 6C 65 72  dentity, trailer
*!*	73 0D 0A 43 6F 6E 74 65 6E 74 2D 54 79 70 65 3A  s..Content-Type:
*!*	20 61 70 70 6C 69 63 61 74 69 6F 6E 2F 78 2D 77   application/x-w
*!*	77 77 2D 66 6F 72 6D 2D 75 72 6C 65 6E 63 6F 64  ww-form-urlencod
*!*	65 64 0D 0A 43 6F 6E 74 65 6E 74 2D 4C 65 6E 67  ed..Content-Leng
*!*	74 68 3A 20 38 31 0D 0A 0D 0A 63 68 61 6E 6E 65  th: 81....channe
*!*	6C 3D 25 32 33 76 66 70 26 6E 69 63 6B 3D 4D 61  l=%23vfp&nick=Ma
*!*	72 74 69 6E 4A 26 73 75 6D 6D 61 72 79 3D 54 65  rtinJ&summary=Te
*!*	73 74 2B 73 74 72 69 6E 67 26 70 61 73 74 65 3D  st+string&paste=
*!*	74 65 73 74 2B 64 61 74 61 26 50 61 73 74 65 2B  test+data&Paste+
*!*	69 74 3D 50 61 73 74 65 2B 69 74                 it=Paste+it     




*!*	50 4F 53 54 20 2F 70 61 73 74 65 20 48 54 54 50  POST /paste HTTP
*!*	2F 31 2E 31 0D 0A 55 73 65 72 2D 41 67 65 6E 74  /1.1..User-Agent
*!*	3A 20 4D 6F 7A 69 6C 6C 61 2F 34 2E 30 20 28 63  : Mozilla/4.0 (c
*!*	6F 6D 70 61 74 69 62 6C 65 3B 20 4D 53 49 45 20  ompatible; MSIE 
*!*	36 2E 30 3B 20 57 69 6E 64 6F 77 73 20 4E 54 20  6.0; Windows NT 
*!*	35 2E 31 3B 20 65 6E 29 20 4F 70 65 72 61 20 38  5.1; en) Opera 8
*!*	2E 30 0D 0A 48 6F 73 74 3A 20 70 61 73 74 65 2E  .0..

*!*	Host: paste.foxshare.net:8888
*!*	Accept: text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1
*!*	Accept-Language: cs;q=1.0,en;q=0.9
*!*	Accept-Charset: windows-1250, utf-8, utf-16, iso-8859-1;q=0.6, *;q=0.1
*!*	Accept-Encoding: deflate, gzip, x-gzip, identity,*;q=0
*!*	Connection: Keep-Alive, TE..TE: deflate,gzip, chunked, identity, trailers
*!*	Content-Type: application/x-www-form-urlencoded
*!*	Content-Length: 81
*!*	channel=%23vfp&nick=MartinJ&summary=Test+string&paste=test+data&Paste+it=Paste+it
